package com.corelogic.infinispan;

import java.util.List;

import com.corelogic.dao.HibernateUtil;
import com.corelogic.dao.KeyValueDAO;
import com.corelogic.domain.KeyValue;

public class HibernateInfiManager {
	
	private KeyValueDAO dao = null;
	
	public void save(Object key, Object value) {
		KeyValue transientInstance = new KeyValue();		
		transientInstance.setKey((String)key);
		transientInstance.setValue((String)value);
		HibernateUtil.beginTransaction();
		dao.save(transientInstance);
		HibernateUtil.commitTransaction();
	}
	
	public Object findById(Class clazz, Object key) {
		HibernateUtil.beginTransaction();		
		Object keyValue = dao.findById(clazz,(String)key);
		HibernateUtil.commitTransaction();
		return keyValue;
	}
	
	public List<Object> findAll(Class clazz) {
		HibernateUtil.beginTransaction();
		List<Object> list = dao.findAll(clazz);		
		HibernateUtil.commitTransaction();
		return list;
	}
	
	public Object delete(Class clazz, Object key) {		
		Object keyValue = this.findById(clazz, key);
		if (keyValue != null) {
			HibernateUtil.beginTransaction();
			dao.delete((KeyValue)keyValue);
			HibernateUtil.commitTransaction();
		}
		return keyValue;
	}
	
	public void deleteAll(Class clazz) {
		HibernateUtil.beginTransaction();
		dao.deleteAll(clazz);
		HibernateUtil.commitTransaction();
	}
	
	public int size() {
		int size = 0;
		HibernateUtil.beginTransaction();
		size = dao.findAll(KeyValue.class).size();
		HibernateUtil.commitTransaction();
		return size;
	}
	
	public boolean isEmpty() {
		boolean isEmpty = false;
		HibernateUtil.beginTransaction();
		isEmpty = dao.findAll(KeyValue.class).isEmpty();
		HibernateUtil.commitTransaction();
		return isEmpty;
	}
	
	public boolean containsKey(Class clazz, Object key) {
		boolean isContains = false;
		HibernateUtil.beginTransaction();
		isContains = (dao.findById(clazz, (String)key) != null);
		HibernateUtil.commitTransaction();
		return isContains;
	}

	public KeyValueDAO getDao() {
		return dao;
	}

	public void setDao(KeyValueDAO dao) {
		this.dao = dao;
	}
}